import { FormRegistryKey, PrimitiveType, TypedFormRegistryKey, TypedFormControlBase } from './model';
import { ValidationErrors } from '@angular/forms';
export declare function deepGet<T, K1 extends keyof T>(object: T, path: [K1], throwOnMiss?: boolean): T[K1];
export declare function deepGet<T, K1 extends keyof T, K2 extends keyof T[K1]>(object: T, path: [K1, K2], throwOnMiss?: boolean): T[K1][K2];
export declare function deepGet<T, K1 extends keyof T, K2 extends keyof T[K1], K3 extends keyof T[K1][K2]>(object: T, path: [K1, K2, K3], throwOnMiss?: boolean): T[K1][K2][K3];
export declare function deepGet<T, K1 extends keyof T, K2 extends keyof T[K1], K3 extends keyof T[K1][K2], K4 extends keyof T[K1][K2][K3]>(object: T, path: [K1, K2, K3, K4], throwOnMiss?: boolean): T[K1][K2][K3][K4];
export declare function deepGet<T, K1 extends keyof T, K2 extends keyof T[K1], K3 extends keyof T[K1][K2], K4 extends keyof T[K1][K2][K3], K5 extends keyof T[K1][K2][K3][K4]>(object: T, path: [K1, K2, K3, K4, K5], throwOnMiss?: boolean): T[K1][K2][K3][K4][K5];
export declare function deepGet<T, K1 extends keyof T, K2 extends keyof T[K1], K3 extends keyof T[K1][K2], K4 extends keyof T[K1][K2][K3], K5 extends keyof T[K1][K2][K3][K4], K6 extends keyof T[K1][K2][K3][K4][K5]>(object: T, path: [K1, K2, K3, K4, K5, K6], throwOnMiss?: boolean): T[K1][K2][K3][K4][K5][K6];
export declare function deepGet<T, K1 extends keyof T, K2 extends keyof T[K1], K3 extends keyof T[K1][K2], K4 extends keyof T[K1][K2][K3], K5 extends keyof T[K1][K2][K3][K4], K6 extends keyof T[K1][K2][K3][K4][K5], K7 extends keyof T[K1][K2][K3][K4][K5][K6]>(object: T, path: [K1, K2, K3, K4, K5, K6, K7], throwOnMiss?: boolean): T[K1][K2][K3][K4][K5][K6][K7];
export declare function deepGet<T, K1 extends keyof T, K2 extends keyof T[K1], K3 extends keyof T[K1][K2], K4 extends keyof T[K1][K2][K3], K5 extends keyof T[K1][K2][K3][K4], K6 extends keyof T[K1][K2][K3][K4][K5], K7 extends keyof T[K1][K2][K3][K4][K5][K6], K8 extends keyof T[K1][K2][K3][K4][K5][K6][K7]>(object: T, path: [K1, K2, K3, K4, K5, K6, K7, K8], throwOnMiss?: boolean): T[K1][K2][K3][K4][K5][K6][K7][K8];
export declare function deepGet<T, K1 extends keyof T, K2 extends keyof T[K1], K3 extends keyof T[K1][K2], K4 extends keyof T[K1][K2][K3], K5 extends keyof T[K1][K2][K3][K4], K6 extends keyof T[K1][K2][K3][K4][K5], K7 extends keyof T[K1][K2][K3][K4][K5][K6], K8 extends keyof T[K1][K2][K3][K4][K5][K6][K7], K9 extends keyof T[K1][K2][K3][K4][K5][K6][K7][K8]>(object: T, path: [K1, K2, K3, K4, K5, K6, K7, K8, K9], throwOnMiss?: boolean): T[K1][K2][K3][K4][K5][K6][K7][K8][K9];
export declare function deepGet(object: any, path: string[], throwOnMiss?: boolean): any;
export declare function deepEquals(x: any, y: any): boolean;
export declare function isPrimitiveType(value: any): value is PrimitiveType;
export declare function isPrimitiveListType(list: any): list is PrimitiveType[];
export declare function uuid(placeholder?: number): string;
export declare function normalizeKey(key: FormRegistryKey<any>): TypedFormRegistryKey<any>;
export declare function raiseError(message: string): never;
export declare function getAliasFromControl(control: TypedFormControlBase): [string] | [];
export declare function extractErrorsWithAliasPrefix(control: TypedFormControlBase, prefixSeparator?: string): ValidationErrors | null;
